=== debian/changelog ===
ros-melodic-jskeus (1.2.5-1bionic) bionic; urgency=high

  * copy gnuplotlib from euslib/jsk.l (#261 <https://github.com/euslisp/jskeus/issues/261>)
  * [irtgeo.l] fix triangulation (#585 <https://github.com/euslisp/jskeus/issues/585>)
  * [irtsensor.l] add :no-window arg in camera-model (#588 <https://github.com/euslisp/jskeus/issues/588>)
  * [irtviewer.l] add irtviewer-no-window, irtviewer without xwindow (#574 <https://github.com/euslisp/jskeus/issues/574>)
  * [irtgraph.l] do not set cost when arc is not costed-arc (#603 <https://github.com/euslisp/jskeus/issues/603>)
  * .travise-osx.sh : osx 10.14-: fix for new libX11.dylib location (/opt/X11/lib:/opt/local/lib -> /usr/local/lib) (#607 <https://github.com/euslisp/jskeus/issues/607>)
  * [irtutil.l] fix minjerk interpolation sometimes returns large acceleration (#596 <https://github.com/euslisp/jskeus/issues/596>)
  * [demo/sample-robot-camera.l] add sample-robot-camera.l : demo to manipulatie camera model (:ray, :screen-point) (#597 <https://github.com/euslisp/jskeus/issues/597>)
  * [irtcollada.l] fix irtcollada problem that mesh poses are incorrect if root link is moved from origin (#600 <https://github.com/euslisp/jskeus/issues/600>)
  * [irtmath.l] add comment to quaternion (#589 <https://github.com/euslisp/jskeus/issues/589>)
  * doc/conf.py: download deb archive.ubuntu.com manually (#581 <https://github.com/euslisp/jskeus/issues/581>)
  * Contributors: Kei Okada, Naoki Hiraoka, Naoya Yamaguchi, Shingo Kitagawa, Yohei Kakiuchi

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 30 Nov 2021 15:00:00 -0000

ros-melodic-jskeus (1.2.4-1bionic) bionic; urgency=high

  * fix for debian release
    
      * check EUSDIR/lisp/image/jpeg is writable (#580 <https://github.com/euslisp/jskeus/issues/580>)
      * add irteus man pages (#579 <https://github.com/euslisp/jskeus/issues/579>)
      * clearfly bullet licensesf( #578 <https://github.com/euslisp/jskeus/issues/578>)
    
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 02 Jul 2020 15:00:00 -0000

ros-melodic-jskeus (1.2.3-1bionic) bionic; urgency=high

  * [irteus/irtmodel.l] In method inverse-kinematics, check length of thre and rthre is equal to move-target (#536 <https://github.com/euslisp/jskeus/issues/536>)
  * clearfy license (#575 <https://github.com/euslisp/jskeus/issues/575>)
    * we forget to change licence to BSD when we move EusLisp license to BSD in 2010, see bottom line of page 3 in https://github.com/euslisp/jskeus/blob/1.0.0/doc/jmanual.pdf, (Version 9.00 is releaced, The license is changed to BSD
  * Fix compile on DOCKER_IMAGE=ubuntu:bionic COLLISION_LIB=PQP (#577 <https://github.com/euslisp/jskeus/issues/577>)
    
      * skip test-torque-from-its-own-weight-common for compiled code
      * simplify every #'identity (mapcar #'(lamnda -> every #'(lambda
      * remove eval-when from test-irt-motion.l, defmethod within defun
      * do not have to use x::*display*, we have dummy-irtviewer
      * use same label function within deftest failes only with COLLISOIN_LIB=PQP
    
  * Contributors: Kei Okada, Tatsuya Ishikawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 28 Jun 2020 15:00:00 -0000

ros-melodic-jskeus (1.2.2-1bionic) bionic; urgency=high

  * [irteus/irtgl.l] add :string method to glviewsurface. (#530 <https://github.com/euslisp/jskeus/issues/530>)
  * add irtstl.l, irtwrl.l : copied from wrl2eus.l and read-stl.l (#248 <https://github.com/euslisp/jskeus/issues/248>)
    
      * fix eus2stl, check if the body has glvertices, see https://github.com/jsk-ros-pkg/jsk_model_tools/pull/208#issuecomment-316715445
      * run triangulation within esu2stl ( https://github.com/jsk-ros-pkg/jsk_model_tools/pull/208#issuecomment-316548668 )
      * add irtstl.l, irtwrl.l : copied from wrl2eus.l and read-stl.l
    
  * Fix triangulation of face-to-tessel-triangle (#562 <https://github.com/euslisp/jskeus/issues/562>)
  * modify node to support image option, and update :write-to-dot so that .dot can include image (#573 <https://github.com/euslisp/jskeus/issues/573>)
    
      * add test code to genrate node with images
      * add node and modify write-to-dot so that .dot can include image
    
  * [:self-collision-check] ignore links which do not have :faces (#571 <https://github.com/euslisp/jskeus/issues/571>)
  * update :self-collision-check, warn message when link without faces is included in collision-check-pairs
  * Add eusbullet for using bullet collision function (implement with c defun) (#570 <https://github.com/euslisp/jskeus/issues/570>)
    
      * add test-self-collision-check-pqp/bullet
      * fix btmakemeshmodel when faces is nil
      * CBULLE.cpp print 'BT_MakeMeshModel with numVertices == 0'
      * do not add pqp triangle to object which do not have :faces
    
  * [irteus/irtmath.l] Add inverse matrix of complex matrix and eigen decompose considering complex number (#554 <https://github.com/euslisp/jskeus/issues/554>)
    
      * [irteus/irtmath.l] Add documents of functions
      * [irteus/irtmath.l] Fix matrix-determinant check of solve-non-zero-vector-from-det0-matrix
      * [irteus/irtmath.l] Debug print travis matrix-determinant
      * [irteus/irtmath.l] Debug print travis mathtest.l
      * [irteus/irtmath.l] Add inverse matrix of complex matrix and eigen decompose considering complex number
    
  * warn misisng color names (#558 <https://github.com/euslisp/jskeus/issues/558>)
  * add documentation of :calc-walk-pattern-from-footstep-list (#550 <https://github.com/euslisp/jskeus/issues/550>)
  * pythag is nolonger used in irteus/irtc.c (#563 <https://github.com/euslisp/jskeus/issues/563>)
  * fix spelling to pass Debian packaging criteria (#564 <https://github.com/euslisp/jskeus/issues/564>)
  * add save-animgif, save-mpeg, save-image functions (#560 <https://github.com/euslisp/jskeus/issues/560>)
    
      * add with-save-mpeg, with-save-animgif macro

